"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentExeCute = exports.generateSynchronizeComponentExeList = exports.synchronizeExecuteComponentList = void 0;
var fs = require('fs');
var path = require('path');
var os = require('os');
// const util = require('util');
var axios_1 = require("axios");
var lodash_1 = require("lodash");
var i18n_1 = require("../utils/i18n");
var download_manager_1 = require("../utils/download-manager");
var get_manager_1 = require("../config/get/get-manager");
var logger = require("../utils/logger");
var package_type_1 = require("../utils/package-type");
var hook_1 = require("./hook");
var static_variable_1 = require("../constants/static-variable");
var version_1 = require("../utils/version");
var S_COMPONENT_BASE_PATH = path.join(os.homedir(), ".s/components");
var spawnSync = require('child_process').spawnSync;
// const exec = util.promisify(require('child_process').exec);
var TYPE_MAP = (_a = {},
    _a[package_type_1.PackageType.component] = 'Component',
    _a[package_type_1.PackageType.plugin] = 'Plugin',
    _a[package_type_1.PackageType.application] = 'Application',
    _a);
function synchronizeExecuteComponentList(list, index, initData) {
    if (list === void 0) { list = []; }
    if (index === void 0) { index = 0; }
    if (initData === void 0) { initData = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(index >= 0 && index < list.length)) return [3 /*break*/, 2];
                    return [4 /*yield*/, list[index]().then(function (_a) {
                            var name = _a.name, data = _a.data;
                            return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            initData[name] = data;
                                            return [4 /*yield*/, synchronizeExecuteComponentList(list, index + 1, initData)];
                                        case 1: return [2 /*return*/, _b.sent()];
                                    }
                                });
                            });
                        })];
                case 1: return [2 /*return*/, _a.sent()];
                case 2: return [2 /*return*/, initData];
            }
        });
    });
}
exports.synchronizeExecuteComponentList = synchronizeExecuteComponentList;
function generateSynchronizeComponentExeList(_a, equipment) {
    var _this = this;
    var list = _a.list, parse = _a.parse, parsedObj = _a.parsedObj, method = _a.method, params = _a.params;
    return list.map(function (projectName) {
        return function () {
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var projectConfig, componentExecute, Output, e_1, thisMessage, tempMessage, thisMessage, tempMessage;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 3, , 4]);
                            parsedObj.Params = params || '';
                            logger.info(i18n_1.default.__("Start executing project {{projectName}}", { projectName: projectName }));
                            return [4 /*yield*/, equipment(parse, projectName, parsedObj)];
                        case 1:
                            projectConfig = _a.sent();
                            componentExecute = new ComponentExeCute(projectConfig, method, parsedObj.edition);
                            return [4 /*yield*/, componentExecute.init()];
                        case 2:
                            Output = _a.sent();
                            if (parsedObj.edition) { //  兼容新版规范
                                parsedObj.services[projectName].outPut = Output;
                            }
                            else {
                                parsedObj[projectName].Output = Output;
                            }
                            logger.info(i18n_1.default.__("Project {{projectName}} successfully to execute \n\t", { projectName: projectName }));
                            resolve({ name: projectName, data: Output });
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            if (String(e_1).indexOf('method does not exist') !== -1) {
                                process.env['project_error'] = String(true);
                                thisMessage = "> Project Method Error: " + projectName + "\n" + e_1;
                                tempMessage = process.env['project_error_message'] ? process.env['project_error_message'] + "\n" : "";
                                process.env['project_error_message'] = tempMessage + thisMessage;
                                logger.error(i18n_1.default.__("Project {{projectName}} doesn't have the method: {{method}}", { projectName: projectName, method: method }));
                                resolve({});
                            }
                            else {
                                process.env['project_error'] = String(true);
                                thisMessage = "> Project Run Error: " + projectName + "\n" + e_1;
                                tempMessage = process.env['project_error_message'] ? process.env['project_error_message'] + "\n" : "";
                                process.env['project_error_message'] = tempMessage + thisMessage;
                                logger.error(e_1);
                                logger.error(i18n_1.default.__("Project {{projectName}} failed to execute", { projectName: projectName }));
                                resolve({ name: projectName, data: '' });
                            }
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); });
        };
    });
}
exports.generateSynchronizeComponentExeList = generateSynchronizeComponentExeList;
var ComponentExeCute = /** @class */ (function () {
    function ComponentExeCute(componentConfig, method, version) {
        if (version === void 0) { version = '0.0.1'; }
        this.componentConfig = componentConfig;
        this.method = method;
        this.version = version;
        this.isPackageProject = false;
        if (!fs.existsSync(S_COMPONENT_BASE_PATH)) {
            fs.mkdirSync(S_COMPONENT_BASE_PATH);
        }
        var name = version_1.getServiceConfigDetail(this.componentConfig).name;
        this.componentPath = path.join(S_COMPONENT_BASE_PATH, "/" + name);
        this.isPackageProject = fs.existsSync(path.join(this.componentPath, '/package.json'));
    }
    ComponentExeCute.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, name, provider, providerOnlyPrefix, _b, version, temp, tempPath, tempPathFile;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = version_1.getServiceConfigDetail(this.componentConfig), name = _a.name, provider = _a.provider;
                        providerOnlyPrefix = provider.split('.')[0];
                        _b = this;
                        return [4 /*yield*/, this.getCredentials()];
                    case 1:
                        _b.credentials = (_c.sent()) || {};
                        // 将密钥缓存到临时环境变量中
                        try {
                            process.env.temp_credentials = JSON.stringify(this.credentials);
                        }
                        catch (e) { }
                        return [4 /*yield*/, fs.existsSync(name)];
                    case 2:
                        if (!_c.sent()) return [3 /*break*/, 3];
                        this.componentPath = name;
                        return [3 /*break*/, 11];
                    case 3:
                        if (!(name.indexOf('@') !== -1)) return [3 /*break*/, 4];
                        temp = name.split('@');
                        name = temp[0];
                        version = temp[1];
                        if (!(name && version)) {
                            throw new Error('Could not get component name and version, please check you component content.');
                        }
                        return [3 /*break*/, 6];
                    case 4: return [4 /*yield*/, this.getRemoteComponentVersion({
                            name: name,
                            provider: providerOnlyPrefix,
                            type: package_type_1.PackageType.component,
                        })];
                    case 5:
                        version = _c.sent();
                        _c.label = 6;
                    case 6:
                        tempPath = path.join(S_COMPONENT_BASE_PATH, "/" + name + "-" + providerOnlyPrefix + "@" + version);
                        tempPathFile = path.join(tempPath, '.s.lock');
                        return [4 /*yield*/, fs.existsSync(tempPathFile)];
                    case 7:
                        if (!!(_c.sent())) return [3 /*break*/, 10];
                        logger.info(i18n_1.default.__("No component {{name}}-{{provider}}@{{version}} is found, it will be downloaded soon, this may take a few minutes......", { name: name, version: version, provider: providerOnlyPrefix }));
                        return [4 /*yield*/, this.downLoadAndUnCompressComponentV2(package_type_1.PackageType.component, name, providerOnlyPrefix, version)];
                    case 8:
                        _c.sent();
                        return [4 /*yield*/, fs.writeFileSync(tempPathFile, name + "-" + version)];
                    case 9:
                        _c.sent();
                        _c.label = 10;
                    case 10:
                        this.componentPath = tempPath;
                        _c.label = 11;
                    case 11: return [4 /*yield*/, this.startExecute()];
                    case 12: return [2 /*return*/, _c.sent()];
                }
            });
        });
    };
    ComponentExeCute.prototype.getCredentials = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, access, provider, configUserInput, getManager, providerMap, accessData;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = version_1.getServiceConfigDetail(this.componentConfig), access = _a.access, provider = _a.provider;
                        configUserInput = { Provider: provider, AliasName: access };
                        getManager = new get_manager_1.GetManager();
                        return [4 /*yield*/, getManager.initAccessData(configUserInput)];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, getManager.getUserSecretID(configUserInput)];
                    case 2:
                        providerMap = _b.sent();
                        accessData = provider && access ? providerMap : providerMap["project." + (access || 'default')] || providerMap[provider + "." + (access || 'default')];
                        return [2 /*return*/, accessData || {}];
                }
            });
        });
    };
    ComponentExeCute.prototype.componentExist = function () {
        return fs.existsSync(this.componentPath);
    };
    ComponentExeCute.prototype.getRemoteComponentVersion = function (_a) {
        var name = _a.name, provider = _a.provider, type = _a.type;
        return __awaiter(this, void 0, void 0, function () {
            var url, version, result, e_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        url = static_variable_1.SERVERLESS_CHECK_COMPONENT_VERSION;
                        version = null;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.get(url, {
                                params: {
                                    name: name,
                                    provider: provider,
                                    type: TYPE_MAP[type],
                                },
                            })];
                    case 2:
                        result = _b.sent();
                        if (result.data && result.data.Response && result.data.Response.Version) {
                            version = result.data.Response.Version;
                        }
                        else {
                            throw new Error('Please Check the provider and component');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _b.sent();
                        logger.error(e_2.message);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, version];
                }
            });
        });
    };
    ComponentExeCute.prototype.getLocalComponentVersion = function () {
        var name = this.componentConfig.Component;
        var pkgFile = path.join(S_COMPONENT_BASE_PATH, name, 'package.json');
        if (!fs.existsSync(pkgFile)) {
            return null;
        }
        var componentPackageJsonObj = require(pkgFile);
        return componentPackageJsonObj.version;
    };
    ComponentExeCute.prototype.preLoadNodeModules = function () {
        return __awaiter(this, void 0, void 0, function () {
            var havePackageJson, haveNodeModules, result;
            return __generator(this, function (_a) {
                havePackageJson = fs.existsSync(path.join(this.componentPath, 'package.json'));
                haveNodeModules = fs.existsSync(path.join(this.componentPath, 'node_modules'));
                // console.log(havePackageJson,haveNodeModules )
                if (havePackageJson && !haveNodeModules) {
                    logger.info('Installing dependencies ...');
                    result = spawnSync('npm install --registry=https://registry.npm.taobao.org', [], { cwd: this.componentPath, stdio: 'inherit', shell: true });
                    if (result && result.status !== 0) {
                        throw Error("> Execute Error");
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    ComponentExeCute.prototype.downLoadAndUnCompressComponent = function (type, name, provider) {
        return __awaiter(this, void 0, void 0, function () {
            var downloadManager, componentPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        downloadManager = new download_manager_1.DownloadManager();
                        componentPath = path.join(S_COMPONENT_BASE_PATH, "" + name);
                        if (!fs.existsSync(componentPath)) {
                            fs.mkdirSync(componentPath);
                        }
                        return [4 /*yield*/, downloadManager.downloadTemplateFromAppCenter(type, name, componentPath, provider)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.downLoadAndUnCompressComponentV2 = function (type, name, provider, version) {
        return __awaiter(this, void 0, void 0, function () {
            var downloadManager, componentPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        downloadManager = new download_manager_1.DownloadManager();
                        componentPath = path.join(S_COMPONENT_BASE_PATH, "/" + name + "-" + provider + "@" + version);
                        if (!fs.existsSync(componentPath)) {
                            fs.mkdirSync(componentPath);
                        }
                        return [4 /*yield*/, downloadManager.downloadTemplateFromAppCenter(type, name, componentPath, provider)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.loadExtends = function () {
        var hooks = version_1.getServiceActions(this.componentConfig, this.version, { method: this.method });
        var hookExecuteInstance = null;
        if (hooks) {
            hookExecuteInstance = new hook_1.Hook(hooks);
        }
        return hookExecuteInstance;
    };
    ComponentExeCute.prototype.loadPreExtends = function (extend) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!extend) return [3 /*break*/, 2];
                        return [4 /*yield*/, extend.executePreHook()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.loadAfterExtend = function (extend) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!extend) return [3 /*break*/, 2];
                        return [4 /*yield*/, extend.executeAfterHook()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.loadComponent = function () {
        return __awaiter(this, void 0, void 0, function () {
            var componentModule;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.preLoadNodeModules()];
                    case 1:
                        _a.sent(); // check and install node_module
                        componentModule = require(this.componentPath);
                        return [2 /*return*/, lodash_1.get(componentModule, "default") ? lodash_1.get(componentModule, "default") : componentModule];
                }
            });
        });
    };
    ComponentExeCute.prototype.invokeMethod = function (ComponentClass, method, data) {
        return __awaiter(this, void 0, void 0, function () {
            var promise;
            var _this = this;
            return __generator(this, function (_a) {
                promise = new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                    var componentInstance, result, e_3;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                componentInstance = new ComponentClass();
                                return [4 /*yield*/, componentInstance[method](data)];
                            case 1:
                                result = _a.sent();
                                resolve(result);
                                return [3 /*break*/, 3];
                            case 2:
                                e_3 = _a.sent();
                                reject(new Error(e_3.message));
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/, promise];
            });
        });
    };
    ComponentExeCute.prototype.executeCommand = function () {
        return __awaiter(this, void 0, void 0, function () {
            var inputs, componentClass, data, ex_1, ex_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        inputs = version_1.getServiceInputs(this.componentConfig, this.version, { method: this.method, credentials: this.credentials });
                        return [4 /*yield*/, this.loadComponent()];
                    case 1:
                        componentClass = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 11]);
                        return [4 /*yield*/, this.invokeMethod(componentClass, this.method, inputs)];
                    case 3:
                        data = _a.sent();
                        return [3 /*break*/, 11];
                    case 4:
                        ex_1 = _a.sent();
                        if (!String(ex_1).includes("componentInstance[method] is not a function")) return [3 /*break*/, 9];
                        _a.label = 5;
                    case 5:
                        _a.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, this.invokeMethod(componentClass, "default", inputs)];
                    case 6:
                        data = _a.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        ex_2 = _a.sent();
                        logger.error("The specified method and default method were not found in the component");
                        return [3 /*break*/, 8];
                    case 8: return [3 /*break*/, 10];
                    case 9: throw Error(ex_1);
                    case 10: return [3 /*break*/, 11];
                    case 11: return [2 /*return*/, data];
                }
            });
        });
    };
    ComponentExeCute.prototype.startExecute = function () {
        return __awaiter(this, void 0, void 0, function () {
            var outData, tempParams, helpArgs, extend, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        outData = {};
                        tempParams = process.env.temp_params || "";
                        helpArgs = tempParams.includes("--help") || tempParams.includes("-h");
                        if (!(process.env['skip-extends'] === 'true' || helpArgs)) return [3 /*break*/, 1];
                        _a = null;
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, this.loadExtends()];
                    case 2:
                        _a = _b.sent();
                        _b.label = 3;
                    case 3:
                        extend = _a;
                        return [4 /*yield*/, this.loadPreExtends(extend)];
                    case 4:
                        _b.sent();
                        return [4 /*yield*/, this.executeCommand()];
                    case 5:
                        outData = _b.sent();
                        return [4 /*yield*/, this.loadAfterExtend(extend)];
                    case 6:
                        _b.sent();
                        return [2 /*return*/, outData];
                }
            });
        });
    };
    return ComponentExeCute;
}());
exports.ComponentExeCute = ComponentExeCute;
//# sourceMappingURL=index.js.map